#version 150

#moj_import <fog.glsl>
#moj_import <color.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform float Time;

in float vertexDistance;
in vec4 vertexColor;
in vec4 lightColor;
in vec2 texCoord0;
in vec4 normal;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    if (color.a < 0.8 /*!dither(color.a, gl_FragCoord)*/) {
        discard;
    }
    if ((color.r == 1 && color.g == 0 && color.b == 1) || ditherFog(vertexDistance, FogEnd, FogEnd + 8, gl_FragCoord)) {
        discard;
    }
    color = color * ColorModulator;
    if (color.r != 0 || color.g != 0 || color.b != 0) {
        color = shade(color, normal, vertexColor, lightColor, vertexDistance, FogStart, FogEnd, FogColor);
    }

    fragColor = color;
}
